import { DataSource, ViewEntity, ViewColumn } from 'typeorm';
import { EquipoTipoEntrada } from '../equipo-tipo-entrada.entity';
import { Equipo } from '../../../equipo/entity/equipo.entity';
import { Carrito } from '../../../carrito/entity/carrito.entity';
import { Modulo } from '../../../modulo/entity/modulo.entity';

@ViewEntity({
  expression: (dataSource: DataSource) =>
    dataSource
      .createQueryBuilder()
      .select('ete.id_equipo_tipo_entrada', 'id_equipo_tipo_entrada')
      .addSelect('ete.id_equipo', 'id_equipo')
      .addSelect('ete.id_tipo_entrada', 'id_tipo_entrada')
      .addSelect('e.id_carrito', 'id_carrito')
      .addSelect('c.id_modulo', 'id_modulo')
      .addSelect('c.id_tipo_carrito', 'id_tipo_carrito')
      .addSelect('m.id_institucion', 'id_institucion')
      .from(EquipoTipoEntrada, 'ete')
      .innerJoin(Equipo, 'e', 'e.id_equipo = ete.id_equipo')
      .innerJoin(Carrito, 'c', 'c.id_carrito = e.id_carrito')
      .innerJoin(Modulo, 'm', 'm.id_modulo = c.id_modulo'),
})
export class InformacionEquipoTipoEntradaView {
  @ViewColumn()
  id_equipo_tipo_entrada: number;

  @ViewColumn()
  id_carrito: number;

  @ViewColumn()
  id_equipo: number;

  @ViewColumn()
  id_institucion: number;

  @ViewColumn()
  id_modulo: number;

  @ViewColumn()
  id_tipo_entrada: number;

  @ViewColumn()
  id_tipo_carrito: number;
}
