import {
  Column,
  Entity,
  JoinColumn,
  ManyToOne,
  PrimaryGeneratedColumn,
} from 'typeorm';
import { Institucion } from '../../institucion/entity/institucion.entity';
import { TipoCarrito } from './tipo-carrito.entity';

@Entity()
export class InstitucionTipoCarrito {
  @PrimaryGeneratedColumn()
  id_institucion_tipo_carrito: number;

  @Column({ type: Boolean, nullable: false, default: false })
  mostrar: boolean;

  @ManyToOne(() => Institucion, (institucion) => institucion.tiposCarrito)
  @JoinColumn({ name: 'id_institucion' })
  institucion: Institucion;

  @ManyToOne(() => TipoCarrito, (tipoCarrito) => tipoCarrito.instituciones, {
    eager: true,
  })
  @JoinColumn({ name: 'id_tipo_carrito' })
  tipoCarrito: TipoCarrito;
}
