import { Column, Entity, OneToMany, PrimaryGeneratedColumn } from 'typeorm';
import { Carrito } from '../../carrito/entity/carrito.entity';
import { Equipo } from '../../equipo/entity/equipo.entity';

@Entity()
export class Marca {
  @PrimaryGeneratedColumn()
  id_marca: number;

  @Column({ type: String, nullable: false, length: 30 })
  marca: string;

  @Column({ type: String, nullable: false, length: 1 })
  tipo: string;

  @OneToMany(() => Carrito, (carrito) => carrito.marca)
  carritos: Carrito[];

  @OneToMany(() => Equipo, (equipo) => equipo.marca)
  equipos: Equipo[];
}
