import {
  IsBoolean,
  IsInt,
  IsNotEmpty,
  IsOptional,
  IsString,
  MaxLength,
} from 'class-validator';

export class UpdateModuloDto {
  @IsInt()
  id_modulo: number;

  @IsBoolean()
  @IsOptional()
  activo?: boolean;

  @IsString()
  @IsNotEmpty()
  @MaxLength(30)
  @IsOptional()
  modulo?: string;
}
