import { DataSource, ViewEntity, ViewColumn } from 'typeorm';
import { Carrera } from '../../../institucion-carrera/entity/carrera.entity';
import { Institucion } from '../../../institucion/entity/institucion.entity';
import { InstitucionCarrera } from '../../../institucion-carrera/entity/institucion-carrera.entity';
import { InstitucionUsuario } from '../../../institucion-usuario/entity/institucion-usuario.entity';
import { Usuario } from '../usuario.entity';

@ViewEntity({
  expression: (dataSource: DataSource) =>
    dataSource
      .createQueryBuilder()
      .select('u.id_usuario', 'id_usuario')
      .addSelect('u.id_tipo_usuario', 'id_tipo_usuario')
      .addSelect('u.nombre', 'nombre')
      .addSelect('u.password', 'password')
      .addSelect('u.usuario', 'usuario')
      .addSelect('iu.activo', 'activo')
      .addSelect('iu.id_institucion_carrera', 'id_institucion_carrera')
      .addSelect('iu.id_institucion_usuario', 'id_institucion_usuario')
      .addSelect('iu.multa', 'multa')
      .addSelect('ic.id_carrera', 'id_carrera')
      .addSelect('ic.id_institucion', 'id_institucion')
      .addSelect('c.carrera', 'carrera')
      .addSelect('i.institucion', 'institucion')
      .from(Usuario, 'u')
      .innerJoin(InstitucionUsuario, 'iu', 'iu.id_usuario = u.id_usuario')
      .innerJoin(
        InstitucionCarrera,
        'ic',
        'ic.id_institucion_carrera = iu.id_institucion_carrera',
      )
      .innerJoin(Carrera, 'c', 'c.id_carrera = ic.id_carrera')
      .innerJoin(Institucion, 'i', 'i.id_institucion = ic.id_institucion'),
})
export class InformacionUsuarioView {
  @ViewColumn()
  id_usuario: number;

  @ViewColumn()
  activo: boolean;

  @ViewColumn()
  carrera: string;

  @ViewColumn()
  id_carrera: number;

  @ViewColumn()
  id_institucion: number;

  @ViewColumn()
  id_institucion_carrera: number;

  @ViewColumn()
  id_institucion_usuario: number;

  @ViewColumn()
  id_tipo_usuario: number;

  @ViewColumn()
  institucion: string;

  @ViewColumn()
  multa: boolean;

  @ViewColumn()
  nombre: string;

  @ViewColumn()
  password: string;

  @ViewColumn()
  usuario: string;
}
